## debian-installer 20040801ubuntu20

=== build/Makefile ===
#!/usr/bin/make -f
#
# Debian Installer system makefile.
# Copyright 2001-2003 by Joey Hess <joeyh@debian.org> and the d-i team.
# Licensed under the terms of the GPL.
#
# This makefile builds a debian-installer system and bootable images from 
# a collection of udebs which it downloads from a Debian archive. See
# README for details.
#

#
# General layout of our build directory hierarchy
#
# build/config/[<subarch>/][<medium>/][<flavour>/]<leaf-config>
# build/tmp/[<subarch>/][<medium>/][<flavour>/]<build-area>
# build/dest/[<subarch>/][<medium>/][<flavour>-]<images>
#
# Items in brackets can be left out if they are superfluous.
#
# These following <image> names are conventional.
#
# For small changeable media (floppies and the like):
# - boot.img, root.img, driver.img
#
# For single bootable images (e.g. tftp boot images):
# - boot.img
#
# For compressed single bootable images (harddisk or hd emulation):
# - boot.img.gz
#
# If those are not bootable:
# - root.img.gz
#
# Raw kernel images:
# - vmlinux or vmlinuz
#
# Example:
#
# dest/
# |-- cdrom-boot.img
# |-- floppy
# |   |-- access
# |   |   |-- boot.img
# |   |   |-- drivers.img
# |   |   `-- root.img
# |   |-- boot.img
# |   |-- cd-drivers.img
# |   |-- net-drivers.img
# |   `-- root.img
# |-- hd-media-boot.img.gz
# `-- netboot
#     |-- initrd.gz
#     `-- vmlinuz
#

# Add to PATH so dpkg will always work, and so local programs will be found.
PATH := $(PATH):/usr/sbin:/sbin:.

# We don't want this to be run each time we re-enter.
ifndef DEB_HOST_ARCH
DEB_HOST_ARCH = $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_GNU_CPU = $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_GNU_SYSTEM = $(shell dpkg-architecture -qDEB_HOST_GNU_SYSTEM)
export DEB_HOST_ARCH DEB_HOST_GNU_CPU DEB_HOST_GNU_SYSTEM
endif

# We loop over all needed combinations of ARCH, SUBARCH, MEDIUM, FLAVOUR
# via recursive make calls. ARCH is constant, we don't support
# crosscompiling.
ARCH = $(DEB_HOST_ARCH)

#
# By default, we just advertise what we can do.
#
.PHONY: all
all: list

#
# Globally useful variables.
#
targetstring = $(patsubst _%,%,$(if $(SUBARCH),_$(SUBARCH),)$(if $(MEDIUM),_$(MEDIUM),)$(if $(FLAVOUR),_$(FLAVOUR),))
targetdirs = $(subst _,/,$(targetstring))


#
# Configurations for the varying ARCH, SUBARCH, MEDIUM, FLAVOUR.
# For simplicity, we use a similiar tree layout for config/, tmp/
# and dest/.
#
# Cheap trick: if one of the variables isn't defined, we run in
# a non-existing file and ignore it.
#
include config/common
include config/dir
-include config/local
-include config/$(ARCH).cfg
-include config/$(ARCH)/$(SUBARCH).cfg
-include config/$(ARCH)/$(SUBARCH)/$(MEDIUM).cfg
-include config/$(ARCH)/$(SUBARCH)/$(MEDIUM)/$(FLAVOUR).cfg

#
# Useful command sequences
#
define submake
  $(MAKE) --no-print-directory
endef

define recurse_once
  @set -e; $(submake) $(1)_$(2)
endef

define recurse_many
  @set -e; $(foreach var,$($(1)_SUPPORTED),$(submake) $(2)_$(3) $(1)=$(var);)
endef

define recurse
  $(if $($(1)_SUPPORTED),$(call recurse_many,$(1),$(2),$(3)),$(call recurse_once,$(2),$(3)))
endef

define genext2fs-userdevfs
  genext2fs -d $(TREE) -b $(USERDEVFS_SIZE) -r 0 -f userdevfs-dev.txt
endef

define genext2fs
  genext2fs -d $(TREE) -b `expr $$(du -s $(TREE) | cut -f 1) + $$(expr $$(find $(TREE) | wc -l) \* 2)` -r 0
endef

define e2fsck
  e2fsck -fy
endef

define mkcramfs
  mkcramfs $(TREE)
endef

#
# A generic recursion rule
#
.PHONY: all_%
all_%:
	@install -d $(STAMPS)
	$(call recurse,SUBARCH,subarch,$*)

.PHONY: subarch_%
subarch_%:
	$(call recurse,MEDIUM,medium,$*)

.PHONY: medium_%
medium_%:
	$(call recurse,FLAVOUR,flavour,$*)

.PHONY: flavour_%
flavour_%:
	$(if $(targetstring),@$(submake) _$*)

#
# Validate a targetstring, echo env variables for valid ones
#
.PHONY: validate_%
validate_%:
	@set -e; \
	SUBARCH= var='$(subst _, ,$(subst validate_,,$@))'; \
	tmp=$$(echo $$var |sed 's/[ ].*$$//'); \
	[ -z '$(SUBARCH_SUPPORTED)' ] || [ -z "$$tmp" ] || [ -z "$$(echo $(SUBARCH_SUPPORTED) |grep -w $$tmp)" ] || SUBARCH=$$tmp; \
	$(submake) medium_validate SUBARCH=$$SUBARCH var="$$var"

.PHONY: medium_validate
medium_validate:
	@set -e; \
	MEDIUM= var="$(strip $(patsubst $(SUBARCH)%,%,$(var)))"; \
	tmp=$$(echo $$var |sed 's/[ ].*$$//'); \
	[ -z '$(MEDIUM_SUPPORTED)' ] || [ -z "$$tmp" ] || [ -z "$$(echo $(MEDIUM_SUPPORTED) |grep -w $$tmp)" ] || MEDIUM=$$tmp; \
	$(submake) flavour_validate MEDIUM=$$MEDIUM var="$$var"

.PHONY: flavour_validate
flavour_validate:
	@set -e; \
	FLAVOUR= var="$(strip $(patsubst $(MEDIUM)%,%,$(var)))"; \
	tmp=$$(echo $$var |sed 's/[ ].*$$//'); \
	[ -z '$(FLAVOUR_SUPPORTED)' ] || [ -z "$$tmp" ] || [ -z "$$(echo $(FLAVOUR_SUPPORTED) |grep -w $$tmp)" ] || FLAVOUR=$$tmp; \
	$(submake) finish_validate FLAVOUR=$$FLAVOUR var="$$var"

.PHONY: finish_validate
finish_validate:
	@set -e; \
	var="$(strip $(patsubst $(FLAVOUR)%,%,$(var)))"; \
	if [ -z "$$var" ]; then \
		echo SUBARCH=$$SUBARCH MEDIUM=$$MEDIUM FLAVOUR=$$FLAVOUR; \
	else \
		echo SUBARCH= MEDIUM= FLAVOUR=; \
	fi;


#
# List all targets useful for direct invocation.
#
.PHONY: list
list:
	@echo "Useful targets:"
	@echo
	@echo "list"
	@echo "all_build"
	@echo "stats"
	@echo "all_clean"
	@echo "reallyclean"
	@echo
	@$(submake) all_list

.PHONY: _list
_list:
	@set -e; \
	echo build_$(targetstring); \
	echo stats_$(targetstring); \
	$(if $(findstring $(MEDIUM),$(WRITE_MEDIA)),echo write_$(targetstring);) \
	echo clean_$(targetstring); \
	echo rebuild_$(targetstring); \
	echo demo_$(targetstring); \
	echo shell_$(targetstring); \
	echo uml_$(targetstring); \
	echo qemu_$(targetstring); \
	echo


#
# Clean all targets.
#
.PHONY: reallyclean
reallyclean: all_clean
	rm -rf $(APTDIR) $(APTDIR).udeb $(APTDIR).deb $(BASE_DEST) $(BASE_TMP) $(SOURCEDIR) $(DEBUGUDEBDIR)
	rm -f sources.list sources.list.udeb sources.list.deb
	rm -rf $(UDEBDIR) $(STAMPS)

# For manual invocation, we provide a generic clean rule.
.PHONY: clean_%
clean_%:
	@$(submake) _clean $(shell $(submake) $(subst clean_,validate_,$@))
	./update-manifest

# The general clean rule.
.PHONY: _clean
_clean: tree_umount
	@[ -n "$(SUBARCH) $(MEDIUM) $(FLAVOUR)" ] || { echo "invalid target"; false; }
	-rm -f $(STAMPS)tree-unpack-$(targetstring)-stamp $(STAMPS)tree-$(targetstring)-stamp $(STAMPS)extra-$(targetstring)-stamp $(STAMPS)get_udebs-$(targetstring)-stamp
	rm -f $(TEMP)/diskusage.txt
	rm -f $(TEMP)/all.utf
	rm -f $(TEMP)/unifont.bdf $(TREE)/unifont.bgf
	rm -f pkg-lists/standard-udebs pkg-lists/kernel-module-udebs
	rm -f $(TARGET)
	rm -rf $(TEMP)

#
# all_build is provided automagically, but for manual invocation
# we provide a generic build rule.
#
.PHONY: build_%
build_%:
	@install -d $(STAMPS)
	@$(submake) _build $(shell $(submake) $(subst build_,validate_,$@))

# The general build rule.
.PHONY: _build
_build:
	@[ -n "$(SUBARCH) $(MEDIUM) $(FLAVOUR)" ] || { echo "invalid target"; false; }
	@$(submake) tree_umount $(EXTRATARGETS) $(TARGET)

# Convenience rule to clean and build.
.PHONY: rebuild_%
rebuild_%:
	@$(submake) clean_$(subst rebuild_,,$@) build_$(subst rebuild_,,$@)

#
# The general tree target.
# FIXME: This is way too convoluted.
#
$(STAMPS)tree-unpack-$(targetstring)-stamp: $(STAMPS)get_udebs-$(targetstring)-stamp
	dh_testroot
	cd .. && dpkg-checkbuilddeps
	@rm -f $@

	# This build cannot be restarted, because dpkg gets confused.
	rm -rf $(TREE)
	# Set up the basic files [u]dpkg needs.
	mkdir -p $(DPKGDIR)/info
	touch $(DPKGDIR)/status
	# Create a tmp tree
	mkdir -p $(TREE)/tmp
	# Only dpkg needs this stuff, so it can be removed later.
	mkdir -p $(DPKGDIR)/updates/
	touch $(DPKGDIR)/available

	# Unpack the udebs with dpkg. This command must run as root
	# or fakeroot.
	echo -n > $(TEMP)/diskusage.txt
	set -e; \
	oldsize=0; oldblocks=0; oldcount=0; for udeb in $(UDEBDIR)/*.udeb ; do \
		if [ -f "$$udeb" ]; then \
			pkg=`basename $$udeb` ; \
			dpkg $(DPKG_UNPACK_OPTIONS) --root=$(TREE) --unpack $$udeb ; \
			newsize=`du -bs $(TREE) | awk '{print $$1}'` ; \
			newblocks=`du -s $(TREE) | awk '{print $$1}'` ; \
			newcount=`find $(TREE) -type f | wc -l | awk '{print $$1}'` ; \
			usedsize=`echo $$newsize - $$oldsize | bc`; \
			usedblocks=`echo $$newblocks - $$oldblocks | bc`; \
			usedcount=`echo $$newcount - $$oldcount | bc`; \
			version=`dpkg-deb --info $$udeb | grep Version: | awk '{print $$2}'` ; \
			echo " $$usedsize B - $$usedblocks blocks - $$usedcount files from $$pkg (version $$version)" >>$(TEMP)/diskusage.txt;\
			oldsize=$$newsize ; \
			oldblocks=$$newblocks ; \
			oldcount=$$newcount ; \
		fi; \
	done
	sort -n < $(TEMP)/diskusage.txt > $(TEMP)/diskusage.txt.new && \
		mv $(TEMP)/diskusage.txt.new $(TEMP)/diskusage.txt
	grep-dctrl -nsPackage,Version '' $(TREE)/var/lib/dpkg/status | \
		perl -nle '$$p = $$_; $$v = <>; chomp $$v; <>; print "$$p $$v"' | \
		sort > $(TEMP_INITRD_LIST)

	# Clean up after dpkg.
	rm -rf $(DPKGDIR)/updates
	rm -f $(DPKGDIR)/available $(DPKGDIR)/*-old $(DPKGDIR)/lock

ifdef KERNELVERSION
	# Set up modules.dep, ensure there is at least one standard dir (kernel
	# in this case), so depmod will use its prune list for archs with no
	# modules.
	#
	set -e; \
	$(foreach VERSION,$(KERNELVERSION), \
		sysmap_name=; sysmap_opt=; \
		if [ -n "$(VERSIONED_SYSTEM_MAP)" ]; then \
			[ ! -e $(TREE)/boot/System.map-$(VERSION) ] || sysmap_name="$(TREE)/boot/System.map-$(VERSION)"; \
		else \
			[ ! -e $(TREE)/boot/System.map ] || sysmap_name="$(TREE)/boot/System.map"; \
		fi; \
		[ -z "$$sysmap_name" ] || sysmap_opt="-F $$sysmap_name"; \
		if [ -d $(TREE)/lib/modules/$(VERSION) ]; then \
			mkdir -p $(TREE)/lib/modules/$(VERSION)/kernel; \
			$(shell ./choose-subarch-env $(VERSION)) depmod $$sysmap_opt -q -a -b $(TREE)/ $(VERSION); \
		fi; \
		[ -z "$$sysmap_name" ] || mv $$sysmap_name $(TEMP);)

	# These files depmod makes are used by hotplug, and we shouldn't
	# need them, yet anyway.
	find $(TREE)/lib/modules/ -name 'modules*' \
		-not -name modules.dep -not -type d | xargs rm -f

	# These files are used to build special kernel images for some
	# subarchitectures. Move them out of the way.
	if [ -d $(TREE)/usr/lib/kernel-image-$(KERNELVERSION) ]; then \
		mv $(TREE)/usr/lib/kernel-image-$(KERNELVERSION) $(TEMP)/lib; \
	fi
endif

ifdef KERNELNAME
	# Move the kernel image out of the way.
	$(foreach name,$(KERNELNAME), \
		mv -f $(TREE)/boot/$(name) $(TEMP)/$(name);)
	rmdir $(TREE)/boot/
endif

ifdef EXTRAFILES
	# Copy in any extra files.
	set -e; \
	for file in $(EXTRAFILES); do \
		mkdir -p $(TREE)/`dirname $$file`; \
		cp -a $$file $(TREE)/$$file; \
	done
endif

ifdef EXTRALIBS
	# Copy in any extra libs.
	set -e; \
	for file in $(EXTRALIBS); do \
		mkdir -p $(TREE)/`dirname $$file`; \
		cp -a $$file $(TREE)/$$file; \
	done
endif

	@touch $@


$(STAMPS)tree-$(targetstring)-stamp: $(STAMPS)tree-unpack-$(targetstring)-stamp
	# Create a dev tree.
	mkdir -p $(TREE)/dev
	# Always needed, in case devfs is not mounted on boot.
	# userdevfs uses userdevfs-dev.txt w/genext2fs
ifndef USERDEVFS
	mknod $(TREE)/dev/console c 5 1
	mknod $(TREE)/dev/null c 1 3
endif

ifdef EXTRADRIVERS
	# Unpack the udebs of additional driver disks, so mklibs runs on them too.
	mkdir -p $(EXTRADRIVERSDIR)
	mkdir -p $(EXTRADRIVERSDPKGDIR)/info $(EXTRADRIVERSDPKGDIR)/updates
	touch $(EXTRADRIVERSDPKGDIR)/status $(EXTRADRIVERSDPKGDIR)/available
	dpkg $(DPKG_UNPACK_OPTIONS) --root=$(EXTRADRIVERSDIR) --unpack \
		$(wildcard $(foreach dir,$(EXTRADRIVERS),$(dir)/*.udeb))
endif

	# Library reduction. Existing libs from udebs are put in the udeblibs
	# directory and mklibs is made to use those in preference to the
	# system libs.
	rm -rf $(TEMP)/udeblibs
	mkdir -p $(TEMP)/udeblibs
	-cp -a `find $(TREE)/lib -type f -name '*.so.*'` $(TEMP)/udeblibs
	mkdir -p $(TREE)/lib
	$(MKLIBS) -L $(TREE)/usr/lib -L $(TEMP)/udeblibs -v -d $(TREE)/lib --root=$(TREE) `find $(TEMP) -type f -perm +0111 -o -name '*.so' | grep -v udeblibs`
	rm -rf $(TEMP)/udeblibs

	# Add missing symlinks for libraries

=== debian/changelog ===
debian-installer (20040801ubuntu20) warty; urgency=low

  * Manual changes:
    - Refer to 'Ubuntu 4.10 "Warty Warthog"' rather than just 'Ubuntu 4.10'.
    - howto/installation-howto.xml: Ubuntu branding. Fix up for Ubuntu
      installer modifications.
    - install-methods/official-cdrom.xml: Link to releases.ubuntulinux.org.
  * Install Ubuntu splash image, so that pxeboot.tar.gz now has the correct
    image too (closes: Ubuntu #2343).

 -- Colin Watson <cjwatson@canonical.com>  Mon, 18 Oct 2004 17:31:23 +0100

debian-installer (20040801ubuntu19) warty; urgency=low

  * Manual changes:
    - Build English only.
    - Point "latest version of this manual" links at
      archive.ubuntulinux.org.
    - welcome/doc-organization.xml: Brand. Fix link to latest version.
    - welcome/getting-newest-doc.xml: Remove links to Debian release pages.
    - welcome/about-copyright.xml: Brand. Refer to multiverse rather than
      contrib and non-free. Link to the Ubuntu License Policy.
    - appendix/chroot-install.xml: Fix release name in debootstrap
      invocation. Add an "Install the Ubuntu Desktop" section.

 -- Colin Watson <cjwatson@canonical.com>  Tue, 12 Oct 2004 17:42:55 +0100

debian-installer (20040801ubuntu18) warty; urgency=low

  * Manual changes:
    - welcome/what-is-debian.xml: Add an "Ubuntu and Debian" section, with
      text from the Ubuntu web site.
    - using-d-i/components.xml, using-d-i/modules/archive-copier.xml:
      Document archive-copier.
    - Brand the appendix on partitioning, accidentally missed out earlier.
    - partitioning/tree.xml: Document /media, /srv, and /sys. Mention rough
      /usr requirements for an Ubuntu desktop installation.

 -- Colin Watson <cjwatson@canonical.com>  Tue, 12 Oct 2004 00:13:23 +0100

debian-installer (20040801ubuntu17) warty; urgency=low

  * Manual changes:
    - Ubuntu-brand the remainder of the manual.
    - Comment out references to hd-media and floppy booting and references
      to unsupported powerpc hardware for now.
    - welcome/welcome.xml: Drop the "What is Debian GNU/Linux?" section.
    - install-methods/install-methods.xml: Comment out automatic
      installation section; support for this is scheduled for Hoary.
    - install-methods/official-cdrom.xml: Ubuntu comes on only one CD.
    - boot-installer/parameters.xml: Default priority is critical, not high.
    - boot-installer/trouble.xml: Direct bug reports to ubuntu-users for
      now.
    - using-d-i/using-d-i.xml: Default priority is critical, not high. Don't
      mention partitioner or partconf. Briefly document archive-copier.
    - using-d-i/modules/partman.xml: We don't have the "partition free space
      on a drive" option at the top level of partman-auto.
    - boot-new/boot-new.xml: Comment out debian-guide reference.
    - boot-new/modules/timezone.xml: UTC question won't be asked if Ubuntu
      is the only installed OS.
    - boot-new/modules/shadow.xml: Document our root password arrangements.
    - boot-new/modules/ppp.xml: Comment out; we don't configure PPP.
    - boot-new/modules/packages.xml: Replace tasksel text with a note that
      the Ubuntu desktop will be automatically installed.
    - boot-new/modules/mta.xml: Comment out; we configure the MTA for local
      delivery only.
    - post-install/orientation.xml: Mention synaptic.
    - post-install/kernel-baking.xml: Remove some obsolete claims.
    - appendix/files.xml: Update disk space estimates. Drop tasksel sizes.
    - appendix/chroot-install.xml: Update disk space estimates. Drop
      reference to RPM port of Debian's debootstrap package.
      s/kernel-image/linux-image/g. Mention /sys.
    - administrivia/administrivia.xml: Direct bug reports to ubuntu-users
      for now.
    - administrivia/contributors.xml: Note my changes.

 -- Colin Watson <cjwatson@canonical.com>  Sun, 10 Oct 2004 18:46:59 +0100

debian-installer (20040801ubuntu16) warty; urgency=low

  * Ubuntu-brand chapter 3 of the manual.
  * Move to 2.6.8.1-3 kernels.
  * Backport from Debian at Mark's request:
    - Add page markers to the syslinux help screens.
  * Expand the documentation of 'custom' a bit.

 -- Colin Watson <cjwatson@canonical.com>  Mon, 27 Sep 2004 23:14:58 +0100

debian-installer (20040801ubuntu15) warty; urgency=low

  * Update substantial parts of the installation manual (English only for
    now) from Debian.
  * Build the manual for just amd64, i386, and powerpc.
  * Add amd64 to buildone.sh so that it can build. (Might not build very
    *well*, though.)
  * First steps at Ubuntu branding. Lots left to do. Some phrasing may be
    bizarre, so bear with me.
  * Add a "What is Ubuntu?" section; http://www.ubuntulinux.org/ supplied
    the text.
  * Unset supports-floppy-boot and bootable-usb for all our architectures,
    since we don't support those methods anywhere yet.
  * Tag a few more sections of the manual with
    condition="supports-floppy-boot" or condition="bootable-usb" to make
    this work better.

 -- Colin Watson <cjwatson@canonical.com>  Thu, 23 Sep 2004 02:24:59 +0100

debian-installer (20040801ubuntu14) warty; urgency=low

  * Add acpi-modules to amd64 initrds.
  * Backport from Debian (Joey Hess, Colin Watson) for Warty #1337:
    - Add "--" to the end of the syslinux and yaboot kernel append lines so
      user-params can work.

 -- Colin Watson <cjwatson@canonical.com>  Tue, 21 Sep 2004 01:52:23 +0100

debian-installer (20040801ubuntu13) warty; urgency=low

  * Update disk space estimates in boot screens (350 MB for custom, 1.8 GB
    for desktop).
  * Finish boot screen branding.

 -- Colin Watson <cjwatson@canonical.com>  Wed, 15 Sep 2004 02:51:33 +0100

debian-installer (20040801ubuntu12) warty; urgency=low

  * Move to 2.6.8.1-2 kernels.

 -- Colin Watson <cjwatson@canonical.com>  Sun, 12 Sep 2004 11:40:42 +0100

debian-installer (20040801ubuntu11) warty; urgency=low

  * Merge from Debian (Debian bug #264584):


=== debian/control ===
Source: debian-installer
Section: devel
Priority: extra
Build-Depends: apt, bc, slang1-utf8-pic, libnewt-pic, syslinux (>= 2.04-1) [i386 amd64], sysutils [i386 amd64], dosfstools [i386 ia64 m68k amd64], libdiscover1-pic [!s390 !s390x], libdiscover1 [!s390 !s390x], ncurses-base, genext2fs (>= 1.3-5), e2fsprogs, mklibs (>= 0.1.15), modutils, glibc-pic, mtools (>= 3.9.9-1) [i386 ia64 m68k amd64], bf-utf-source [!s390 !s390x], upx-ucl-beta [i386], libbogl-dev, libtextwrap1, debhelper (>= 4), tip22 [mips], yaboot [powerpc], mkisofs, elilo [ia64], fakeroot, aboot (>= 0.9b-2) [alpha], silo [sparc], libdebian-installer4, libdebconfclient0, libiw27, palo [hppa], docbook, docbook-xml, docbook-xsl, xsltproc, genisovh [mips], grep-dctrl, bzip2 [powerpc], libparted1.6-0, delo [mipsel], genromfs [sparc], hfsutils [powerpc], colo (>= 1.10-1) [mipsel], atari-bootstrap [m68k], vmelilo [m68k], m68k-vme-tftplilo [m68k], sparc-utils [sparc], cramfsprogs [powerpc], mkvmlinuz [powerpc], module-init-tools [i386 powerpc amd64], libnewt0.51
Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Uploaders: Joey Hess <joeyh@debian.org>, Alastair McKinstry <mckinstry@computer.org>, Joshua Kwan <joshk@triplehelix.org>
Standards-Version: 3.6.1.0

Package: debian-installer-manual
Architecture: any
Description: Debian installation manual
 This package contains the Debian installation manual, in a variety of
 languages. It also includes the installation HOWTO, and a variety of
 developer documentation for the Debian Installer.

=== debian/rules ===
#!/usr/bin/make -f

ARCH=$(shell dpkg-architecture -qDEB_BUILD_ARCH)
VERSION=$(shell LC_ALL=C dpkg-parsechangelog | grep ^Version: | cut -d ' ' -f 2)
DISTRIBUTION=$(shell LC_ALL=C dpkg-parsechangelog | grep ^Distribution: | cut -d ' ' -f 2)
ifeq (${DISTRIBUTION},unstable)
DISTRIBUTION=testing
endif
ifeq (${DISTRIBUTION},UNRELEASED)
DISTRIBUTION=unstable
endif

ARCHIVEDIR=installer-$(ARCH)
DESTDIR=$(ARCHIVEDIR)/$(VERSION)
IMAGEDIR=$(DESTDIR)/images
TARNAME=debian-installer-images_$(VERSION)_$(ARCH).tar.gz

clean:
	dh_testdir
	dh_testroot
	dh_clean build-stamp
	$(MAKE) -C build reallyclean

build: build-stamp
build-stamp:
	rm -f $@
	fakeroot $(MAKE) -C build all_build stats SUITE=$(DISTRIBUTION)
	touch $@
	
build-manual:
	-rm -rf debian/tmp/$(DESTDIR)/doc/manual
	cd doc/manual/build && \
	        official_build=1 \
		destination=$(shell pwd)/debian/tmp/$(DESTDIR)/doc/manual \
		architectures=$(ARCH) noarchdir=1 ./build.sh

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_install
	install -d debian/tmp/$(DESTDIR)/doc
	cp debian/*.html doc/INSTALLATION-HOWTO debian/tmp/$(DESTDIR)/doc
	debian/rules build-manual
	install -d debian/tmp/$(IMAGEDIR)
	cp -a build/dest/* debian/tmp/$(IMAGEDIR)
	cd debian/tmp/$(IMAGEDIR) && md5sum `find . -type f` > MD5SUMS
	ln -s $(VERSION) debian/tmp/$(ARCHIVEDIR)/current

binary-arch: install  
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs debian/tmp/$(DESTDIR)/doc/manual
	dh_installdocs -X historic -X manual doc/*
	dh_compress
	dh_fixperms
	dh_gencontrol -- -Vkernel:Package='$(KERNELPACKAGE)'
	dh_builddeb
	cd debian/tmp && tar czvf ../../../$(TARNAME) .
	dpkg-distaddfile $(TARNAME) byhand -

binary-indep:

binary: binary-indep binary-arch 
.PHONY: build clean binary-indep binary-arch binary install

## debian-installer 20041227ubuntu24

=== build/Makefile ===
--- 
+++ 
@@ -119,7 +119,7 @@
 endef
 
 define genext2fs-userdevfs
-  genext2fs -d $(TREE) -b $(USERDEVFS_SIZE) -r 0 -f userdevfs-dev.txt
+  genext2fs -d $(TREE) -b $(USERDEVFS_SIZE) -r 0 -f userdevfs-devs
 endef
 
 define genext2fs
@@ -201,6 +201,7 @@
 	@echo
 	@echo "list"
 	@echo "all_build"
+	@echo "all_rebuild"
 	@echo "stats"
 	@echo "all_clean"
 	@echo "reallyclean"
@@ -246,7 +247,7 @@
 	rm -f $(TEMP)/all.utf
 	rm -f $(TEMP)/unifont.bdf $(TREE)/unifont.bgf
 	rm -f pkg-lists/standard-udebs pkg-lists/kernel-module-udebs
-	rm -f $(TARGET)
+	rm -rf $(TARGET)
 	rm -rf $(TEMP)
 
 #
@@ -264,10 +265,14 @@
 	@[ -n "$(SUBARCH) $(MEDIUM) $(FLAVOUR)" ] || { echo "invalid target"; false; }
 	@$(submake) tree_umount $(EXTRATARGETS) $(TARGET)
 
-# Convenience rule to clean and build.
+# Convenience rules to clean and build.
 .PHONY: rebuild_%
 rebuild_%:
 	@$(submake) clean_$(subst rebuild_,,$@) build_$(subst rebuild_,,$@)
+
+.PHONY: _rebuild
+_rebuild:
+	@$(submake) _clean _build
 
 #
 # The general tree target.
@@ -340,16 +345,25 @@
 		fi; \
 		[ -z "$$sysmap_name" ] || mv $$sysmap_name $(TEMP);)
 
-	# These files depmod makes are used by hotplug, and we shouldn't
-	# need them, yet anyway.
-	find $(TREE)/lib/modules/ -name 'modules*' \
-		-not -name modules.dep -not -type d | xargs rm -f
+	# These files depmod makes are used by hotplug, if it's being used;
+	# otherwise, we shouldn't need them. Some files aren't even used by
+	# hotplug, so never include them.
+	if [ -d $(TREE)/etc/hotplug ]; then \
+		find $(TREE)/lib/modules/ -name 'modules*' \
+			-not -name modules.dep -not -name 'modules.*map' \
+			-not -type d | xargs rm -f; \
+	else \
+		find $(TREE)/lib/modules/ -name 'modules*' \
+			-not -name modules.dep -not -type d | xargs rm -f; \
+	fi
 
 	# These files are used to build special kernel images for some
 	# subarchitectures. Move them out of the way.
-	if [ -d $(TREE)/usr/lib/kernel-image-$(KERNELVERSION) ]; then \
-		mv $(TREE)/usr/lib/kernel-image-$(KERNELVERSION) $(TEMP)/lib; \
-	fi
+	$(foreach VERSION,$(KERNELVERSION), \
+		if [ -d $(TREE)/usr/lib/kernel-image-$(VERSION) ]; then \
+			mv $(TREE)/usr/lib/kernel-image-$(VERSION) \
+				$(TEMP)/lib; \
+		fi;)
 endif
 
 ifdef KERNELNAME
@@ -384,7 +398,7 @@
 	# Create a dev tree.
 	mkdir -p $(TREE)/dev
 	# Always needed, in case devfs is not mounted on boot.
-	# userdevfs uses userdevfs-dev.txt w/genext2fs
+	# userdevfs uses userdevfs-devs w/genext2fs
 ifndef USERDEVFS
 	mknod $(TREE)/dev/console c 5 1
 	mknod $(TREE)/dev/null c 1 3
@@ -401,12 +415,3 @@
 
 	# Library reduction. Existing libs from udebs are put in the udeblibs
 	# directory and mklibs is made to use those in preference to the
-	# system libs.
-	rm -rf $(TEMP)/udeblibs
-	mkdir -p $(TEMP)/udeblibs
-	-cp -a `find $(TREE)/lib -type f -name '*.so.*'` $(TEMP)/udeblibs
-	mkdir -p $(TREE)/lib
-	$(MKLIBS) -L $(TREE)/usr/lib -L $(TEMP)/udeblibs -v -d $(TREE)/lib --root=$(TREE) `find $(TEMP) -type f -perm +0111 -o -name '*.so' | grep -v udeblibs`
-	rm -rf $(TEMP)/udeblibs
-
-	# Add missing symlinks for libraries

=== debian/changelog ===
debian-installer (20041227ubuntu24) hoary; urgency=low

  * Add nic-firmware to netboot initrds (closes: #8390).
  * Update copyright notices to 2005.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue,  5 Apr 2005 18:32:08 +0100

debian-installer (20041227ubuntu23) hoary; urgency=low

  * Fix powerpc build (copy yaboot to the right place).

 -- Colin Watson <cjwatson@ubuntu.com>  Sat, 26 Mar 2005 17:15:06 +0000

debian-installer (20041227ubuntu22) hoary; urgency=low

  * Manual changes:
    - appendix/example-preseed.xml: Document how to pick a particular
      interface with netcfg/choose_interface. Update locale preseeding
      advice to localechooser. Add advice on preseeding a netboot interface
      on the kernel command line. Note that kernel 2.6.9 has raised kernel
      command line limits.
    - install-methods/automatic-install.xml: Document Kickstart
      installations (currently only the basics, a reference to Red Hat's
      documentation, and the differences from Anaconda).
  * Ship yaboot in powerpc netboot/hd-media directories.
  * Drop ia64 boot.img size to 16MB, to save CD space.

 -- Colin Watson <cjwatson@ubuntu.com>  Sat, 26 Mar 2005 14:18:04 +0000

debian-installer (20041227ubuntu21) hoary; urgency=low

  * Move to 2.6.10-5 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 15 Mar 2005 19:14:43 +0000

debian-installer (20041227ubuntu20) hoary; urgency=low

  * Fix netboot image build problem.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed,  2 Mar 2005 12:41:38 +0000

debian-installer (20041227ubuntu19) hoary; urgency=low

  * Rename debian-installer to ubuntu-installer in netboot image tree. (This
    directory name is there so that the installer's files can coexist with
    others on a shared TFTP server, so it should probably be named
    differently by Ubuntu derivatives too.)
  * Clarify syslinux boot message text (thanks, Mark Shuttleworth; closes:
    Ubuntu #7002).
  * Manual changes to note that post-installation logs go in
    /var/log/installer/ now.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue,  1 Mar 2005 21:50:31 +0000

debian-installer (20041227ubuntu18) hoary; urgency=low

  * Remove obsolete file-kickseed and network-kickseed packages from all
    images. initrd-kickseed does everything now.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 25 Feb 2005 20:32:24 +0000

debian-installer (20041227ubuntu17) hoary; urgency=low

  * Add the characters from the decision tree to all.utf
    (which is used as the base for building the font).

 -- Matthias Urlichs <smurf@debian.org>  Fri, 25 Feb 2005 16:52:50 +0100

debian-installer (20041227ubuntu16) hoary; urgency=low

  * Backport from trunk:
    - Fix support for multiple words in KERNELVERSION.
  * Add hppa support, based on a patch by LaMont Jones:
    - build/boot/hppa/mkiso.conf: Remove obsolete devfs=mount,dall
      init=/linuxrc.
    - build/config/hppa.cfg: 2.6 only; use 2.6.10-4 kernel; kernel images
      named *-hppa{32,64} rather than *-{32,64}.
    - build/config/hppa/: 2.6 only.
    - build/config/hppa/miniiso.cfg: Bump ramdisk size to 131072.
    - build/pkg-lists/cdrom/hppa.cfg, build/pkg-lists/floppy/hppa.cfg,
      build/pkg-lists/netboot/hppa.cfg: Remove discover.
    - doc/manual/build/build.sh: Build hppa manual.
    - doc/manual/build/arch-options/hppa: 2.6.10 kernel; remove
      status="not-checked".
  * build/pkg-lists/netboot/: Add pciutils-udeb where not already done.

  * doc/manual/en/preparing/non-debian-partitioning.xml: Ubuntu branding.

  * Add network-kickseed to all images containing network-preseed.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 24 Feb 2005 15:33:33 +0000

debian-installer (20041227ubuntu15) hoary; urgency=low

  * Move to 2.6.10-4 kernels.
  * Add console-keymaps-tree to all images that already have kbd-chooser,
    not just the currently supported ones.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 22 Feb 2005 21:08:08 +0000

debian-installer (20041227ubuntu14) hoary; urgency=low

  * Add keyboard decision tree udeb.

 -- Matthias Urlichs <smurf@debian.org>  Fri, 18 Feb 2005 12:46:50 +0100

debian-installer (20041227ubuntu13) hoary; urgency=low

  * Output debian-cd_info.tar.gz on ia64 with all the boot screens.
  * Add customised boot screens for the ia64 live CD.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 17 Feb 2005 21:19:35 +0000

debian-installer (20041227ubuntu12) hoary; urgency=low

  * Add customised boot screens for the live CD.
  * build/boot/powerpc/boot.msg: Ubuntu branding.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 15 Feb 2005 13:35:11 +0000

debian-installer (20041227ubuntu11) hoary; urgency=low

  * Add file-kickseed to all images containing file-preseed.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed,  9 Feb 2005 18:21:02 +0000

debian-installer (20041227ubuntu10) hoary; urgency=low

  * Backport from trunk:
    - Add support for kernel-specific pkg-lists entries: use lines like
      "package [2.2 2.4]" or "package * [2.6]". Should eventually form a
      simpler replacement for the kernel_specific directory.
  * Add kickseed-common and initrd-kickseed to all images containing
    preseed-common and initrd-preseed.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon,  7 Feb 2005 19:04:25 +0000

debian-installer (20041227ubuntu9) hoary; urgency=low

  * Add zoneinfo-udeb to monolithic builds, for tzsetup-udeb.

  * Move to 2.6.10-3 kernels.

  * Backport from trunk:
    - Add hd-media image for powerpc, including a boot.img.gz designed for
      use on USB sticks.
    - Document USB booting on powerpc. This involved splitting out the
      documentation for USB booting on i386 a bit.
  * Build boot.img.gz version of powerpc netboot, for use as a bootable USB
    image. Unlike amd64 and i386, this currently requires a 16 MB stick.
  * Manual changes:
    - install-methods/usb-setup/i386.xml,
      install-methods/usb-setup/powerpc.xml: Ubuntu branding.

  * Stop using ubuntu/install-type for server installs; preseed base-config
    instead.



=== debian/control ===
Source: debian-installer
Section: devel
Priority: optional
Build-Depends: apt, gnupg, bc, slang1-utf8-pic, libnewt-pic, syslinux (>= 2.11-0.1) [i386 amd64], sysutils [i386 amd64], dosfstools [i386 ia64 m68k amd64], ncurses-base, genext2fs (>= 1.3-7.1), e2fsprogs, mklibs (>= 0.1.15), modutils, glibc-pic, mtools (>= 3.9.9-1) [i386 ia64 m68k amd64], bf-utf-source [!s390 !s390x], upx-ucl-beta (>= 1:1.91+0.20030910cvs-2) [i386], libbogl-dev, libtextwrap1, debhelper (>= 4), tip22 [mips], yaboot [powerpc], mkisofs, elilo [ia64], aboot (>= 0.9b-2) [alpha], silo [sparc], libdebian-installer4, libdebconfclient0, libiw27, palo [hppa], docbook, docbook-xml, docbook-xsl, xsltproc, genisovh [mips], grep-dctrl, bzip2 [powerpc], libparted1.6-12, delo [mipsel], genromfs [sparc], hfsutils [powerpc], colo (>= 1.10-1) [mipsel], sibyl [mips mipsel], atari-bootstrap [m68k], vmelilo [m68k], m68k-vme-tftplilo [m68k], sparc-utils [sparc], cramfsprogs [powerpc ia64], mkvmlinuz [powerpc], module-init-tools [i386 powerpc amd64 hppa ia64 sparc], libnewt0.51, debiandoc-sgml
Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Uploaders: Joey Hess <joeyh@debian.org>, Alastair McKinstry <mckinstry@computer.org>, Joshua Kwan <joshk@triplehelix.org>
Standards-Version: 3.6.1.0

Package: debian-installer-manual
Architecture: any
Description: Debian installation manual
 This package contains the Debian installation manual, in a variety of
 languages. It also includes the installation HOWTO, and a variety of
 developer documentation for the Debian Installer.

## debian-installer 20050317sarge1-0.1amd64

=== debian/changelog ===
debian-installer (20050317sarge1-0.1amd64) stable; urgency=low

  * Don't build the documentation since it doesn't include
    things for amd64.
  * Change kernel from 2.6.8-11 to 2.6.8-12 for amd64, so
    that we actually use the latest version.
  * Disable the monolithic target for amd64.
  * Use cut -d '-' instead of -d '.' to get the date.

 -- Kurt Roeckx <kurt@roeckx.be>  Mon, 14 Aug 2006 16:40:19 +0000

debian-installer (20050317sarge1) stable; urgency=low

  * Frans Pop
    - Add build dependencies needed for PDF and TXT builds of the manual.
    - Make main build script for the manual fail on errors.
    - Introduce cascading stylesheet for the HTML version of the manual.
    - Final update of the manual and translations for Sarge version.
  * Joey Hess
    - Copyright file updates for 2005.
    - Switch amd64 back to 2.6.8 kernel; 2.6.10 is not preferred. Closes: #307306
  * Kurt Roeckx
    - Rename libdevmapper1.00-udeb to libdevmapper1.01-udeb for monolithic
      image. It's only build for amd64.  (Closes: #306976)
    - Change amd64 kernel from 2.6.8-10 to 2.6.8-11.
  * Colin Watson
    - Set default SUITE to sarge.
  * Frans Pop
    - Update kernel versions for Sarge security updates with ABI change.
    - Copyright file update for 2006.
    - Release targeted at Sarge 3.1r3 point release.

 -- Frans Pop <fjp@debian.org>  Fri,  4 Aug 2006 19:19:56 +0200

debian-installer (20050317) unstable; urgency=low

  * Frans Pop
    - Add German and Russian for official builds of the manual
    - Add PDF and TXT formats for official builds of the manual
  * Martin Michlmayr
    - Mention rootdev in the ARM manual, thanks Kyle McMartin.
    - Use the correct TFTP filename for ARM Netwinder.
    - Remove bogus information about noinitrd option from ARM manual.
    - Mention option needed for serial console installations on
      ARM Netwinder, thanks thanks Kyle McMartin.

 -- Joey Hess <joeyh@debian.org>  Thu, 17 Mar 2005 10:54:07 -0500

debian-installer (20050305) unstable; urgency=high

  * Thiemo Seufer
    - Do an e2fsck for the extra floppy images.
    - Handle sparse files in cramfs images more efficiently.
    - Use cramfs images for mips/r4k-ip22 and mips/r5k-ip22.
    - Add cramfsprogs build-dep for mips.
  * Colin Watson
    - Add acpi-modules to the amd64 cdrom, hd-media, monolithic, and netboot
      initrds, so that rootskel can turn the fan on.
    - Use dependency resolution for ide-modules, nic-modules,
      pcmcia-storage-modules, scsi-common-modules, scsi-modules, and
      usb-storage-modules on powerpc, and remove several modules from
      powerpc-extra-modules that only belong on certain images. This removes
      cdrom-core-modules and fs-common-modules from netboot images, and adds
      parport-modules to apus/cdrom (I think it was missing by mistake).
    - Add support for kernel-specific pkg-lists entries: use lines like
      "package [2.2 2.4]" or "package * [2.6]". Should eventually form a
      simpler replacement for the kernel_specific directory.
    - Include initrd.list on amd64/i386 images.
    - Add hd-media image for powerpc, including a boot.img.gz designed for
      use on USB sticks.
    - Document USB booting on powerpc. This involved splitting out the
      documentation for USB booting on i386 a bit.
    - Since power3 and power4 no longer build images with the 2.4 kernel,
      remove their KERNELVERSION_2.4 variables and kernel-build-2.4*
      build-dependencies.
    - Switch libparted1.6-0 build-dependency to libparted1.6-12.
    - Fix support for multiple words in KERNELVERSION.
  * Christian Perrier
    - Add the list of needed characters for Belarussian
    - Add the list of needed characters for Esperanto
  * Martin Michlmayr
    - Switch Cobalt to use the new-style initrd parameter rd_start and
      rd_size.
  * Stephen R. Marenka
    - Add m68k/amiga startup scripts with thanks to and the permission of
      Christian T. Steigies <cts@debian.org>.
  * Frans Pop
    - Implement new-generation build scripts for sarge branch.
    - Make kernel-version for sparc64 ide-modules variable by using an
      #include rather than the full module name.
    - Add gawk and poxml build dependencies (required for the manual)
  * Joshua Kwan
    - Change sparc kernels to use 2.6.8-2 udebs.
  * Joey Hess
    - Add new usb-modules to sparc64 images to support usb keyboard on sun
      blades.
    - Move all utilities in build/ into build/util/, except daily-build,
      which is hardcoded in many cron jobs.
    - Fix two cases where the pkg-lists dependency checker printed warnings
      about dependencies that were actually ok.
    - Manual correction re debconf/priority.
    - Don't fail to build if sources.list has a cdrom entry in it
      (don't try to use the cdrom as a udeb source, either).
    - Switch i386, ia64, alpha, hppa, and s390 to use the -2 kernel abiname.
    - Add text frontend to alpha netboot image for general old-timey keenness.
    - Dropped hppa 2.4 images.
    - Removed various things from the hppa 2.6 netboot initrd to make
      it small enough to work again.
    - Add cdrom-modules to hppa cdrom initrd, this is a new package as of the
      -2 kernel.
    - Add socket-modules to all hppa initrds, also newly modularised.
  * Bdale Garbee
    - hppa 2.6 cdrom initrd needs more modules
  * Kurt Roeckx
    - Remove unused config files for amd64.
    - Update kernel version for amd64 to 2.6.8-10
    - Update netboot and monolithic config files for amd64 to match i386.
  * Sven Luther
    - Adapted to new 2.4.27-3 and 0.64 powerpc kernel .deb and .udebs and
      mkvmlinuz.

 -- Joey Hess <joeyh@debian.org>  Sat,  5 Mar 2005 13:07:49 -0500

=== debian/control ===
Source: debian-installer
Section: devel
Priority: optional
Build-Depends: apt, bc, slang1-utf8-pic, libnewt-pic, syslinux (>= 2.11-0.1) [i386 amd64], sysutils [i386 amd64], dosfstools [i386 ia64 m68k amd64], libdiscover1-pic [!s390 !s390x], libdiscover1 [!s390 !s390x], ncurses-base, genext2fs (>= 1.3-7.1), e2fsprogs, mklibs (>= 0.1.15), modutils, glibc-pic, mtools (>= 3.9.9-1) [i386 ia64 m68k amd64], bf-utf-source [!s390 !s390x], upx-ucl-beta (>= 1:1.91+0.20030910cvs-2) [i386], libbogl-dev, libtextwrap1, debhelper (>= 4), tip22 [mips], yaboot [powerpc], mkisofs, elilo [ia64], aboot (>= 0.9b-2) [alpha], silo [sparc], libdebian-installer4, libdebconfclient0, libiw27, palo [hppa], docbook, docbook-xml, docbook-xsl, xsltproc, genisovh [mips], grep-dctrl, bzip2 [powerpc], libparted1.6-12, delo [mipsel], genromfs [sparc], hfsutils [powerpc], colo (>= 1.10-1) [mipsel], sibyl [mips mipsel], atari-bootstrap [m68k], vmelilo [m68k], m68k-vme-tftplilo [m68k], sparc-utils [sparc], cramfsprogs [powerpc ia64 mips], mkvmlinuz [powerpc], module-init-tools [i386 powerpc amd64 hppa ia64 sparc], libnewt0.51, debiandoc-sgml, openjade, jadetex, docbook-dsssl, gs-common, w3m, gawk, poxml
Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Uploaders: Joey Hess <joeyh@debian.org>, Alastair McKinstry <mckinstry@computer.org>, Joshua Kwan <joshk@triplehelix.org>
Standards-Version: 3.6.1.0

Package: debian-installer-manual
Architecture: any
Description: Debian installation manual
 This package contains the Debian installation manual, in a variety of
 languages. It also includes the installation HOWTO, and a variety of
 developer documentation for the Debian Installer.

=== debian/rules ===
#!/usr/bin/make -f

ARCH=$(shell dpkg-architecture -qDEB_BUILD_ARCH)
VERSION=$(shell LC_ALL=C dpkg-parsechangelog | grep ^Version: | cut -d ' ' -f 2)
DATE=$(shell echo $(VERSION) | cut -d '-' -f 1)
DISTRIBUTION=$(shell LC_ALL=C dpkg-parsechangelog | grep ^Distribution: | cut -d ' ' -f 2)
ifeq (${DISTRIBUTION},stable)
DISTRIBUTION=sarge
endif
ifeq (${DISTRIBUTION},unstable)
DISTRIBUTION=sarge
endif
ifeq (${DISTRIBUTION},UNRELEASED)
DISTRIBUTION=unstable
endif

ARCHIVEDIR=debian/tmp/installer-$(ARCH)
DESTDIR=$(ARCHIVEDIR)/$(DATE)
IMAGEDIR=$(DESTDIR)/images
MANDIR=$(DESTDIR)/doc/manual
MANTMP=$(shell pwd)/doc/manual/build/manual
TARNAME=debian-installer-images_$(VERSION)_$(ARCH).tar.gz

clean:
	dh_testdir
	dh_testroot
	dh_clean build-stamp
	rm -rf $(MANTMP)
	$(MAKE) -C build reallyclean
	$(MAKE) -C doc/devel/partman clean

# Must run as root, so is not run as part of regular build.
build-images:
	$(MAKE) -C build all_build stats \
		SUITE=$(DISTRIBUTION) BUILD_DATE=$(DATE)
	
build: build-stamp
build-stamp:
	rm -f $@
	-rm -rf $(MANTMP)
#	set -e && cd doc/manual/build && \
#	        official_build=1 destination=$(MANTMP) \
#		architectures=$(ARCH) noarchdir=1 ./build.sh

	$(MAKE) -C doc/devel/partman
	
	touch $@

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	
#	install -d $(MANDIR)
#	cp -a $(MANTMP)/* $(MANDIR)
	
	# Inclusion of a sources.list.udeb.local is needed to build d-i for
	# Sarge 3.1r3 including updated kernel udebs. This hack makes sure
	# we also support AMD64 which uses a different mirror.
	if [ $(ARCH) = amd64 ] && [ -f build/sources.list.udeb.local.amd64 ]; then \
		cp build/sources.list.udeb.local.amd64 build/sources.list.udeb.local; \
	fi
	debian/rules build-images

	install -d $(IMAGEDIR)
	cp -a build/dest/* $(IMAGEDIR)
	cd $(IMAGEDIR) && md5sum `find . -type f` > MD5SUMS
	ln -s $(DATE) $(ARCHIVEDIR)/current

binary-arch: install  
	dh_testdir
	dh_testroot
	dh_installchangelogs
#	dh_installdocs $(MANTMP)
	dh_installdocs -X manual doc/* -X Makefile -X partman-doc.sgml
	dh_compress
	dh_fixperms
	dh_gencontrol -- -Vkernel:Package='$(KERNELPACKAGE)'
	dh_builddeb
	cd debian/tmp && tar czvf ../../../$(TARNAME) .
	dpkg-distaddfile $(TARNAME) byhand -

binary-indep:

binary: binary-indep binary-arch 
.PHONY: build build-images clean binary-indep binary-arch binary install

## debian-installer 20050317sarge2

=== build/Makefile ===
--- 
+++ 
@@ -55,7 +55,7 @@
 #
 
 # Add to PATH so dpkg will always work, and so local programs will be found.
-PATH := $(PATH):/usr/sbin:/sbin:.
+PATH := util:$(PATH):/usr/sbin:/sbin
 
 # We don't want this to be run each time we re-enter.
 ifndef DEB_HOST_ARCH
@@ -131,7 +131,7 @@
 endef
 
 define mkcramfs
-  mkcramfs $(TREE)
+  mkcramfs -z $(TREE)
 endef
 
 #
@@ -236,7 +236,7 @@
 .PHONY: clean_%
 clean_%:
 	@$(submake) _clean $(shell $(submake) $(subst clean_,validate_,$@))
-	./update-manifest
+	update-manifest
 
 # The general clean rule.
 .PHONY: _clean
@@ -341,21 +341,14 @@
 		[ -z "$$sysmap_name" ] || sysmap_opt="-F $$sysmap_name"; \
 		if [ -d $(TREE)/lib/modules/$(VERSION) ]; then \
 			mkdir -p $(TREE)/lib/modules/$(VERSION)/kernel; \
-			$(shell ./choose-subarch-env $(VERSION)) depmod $$sysmap_opt -q -a -b $(TREE)/ $(VERSION); \
+			$(shell choose-subarch-env $(VERSION)) depmod $$sysmap_opt -q -a -b $(TREE)/ $(VERSION); \
 		fi; \
 		[ -z "$$sysmap_name" ] || mv $$sysmap_name $(TEMP);)
 
-	# These files depmod makes are used by hotplug, if it's being used;
-	# otherwise, we shouldn't need them. Some files aren't even used by
-	# hotplug, so never include them.
-	if [ -d $(TREE)/etc/hotplug ]; then \
-		find $(TREE)/lib/modules/ -name 'modules*' \
-			-not -name modules.dep -not -name 'modules.*map' \
-			-not -type d | xargs rm -f; \
-	else \
-		find $(TREE)/lib/modules/ -name 'modules*' \
-			-not -name modules.dep -not -type d | xargs rm -f; \
-	fi
+	# These files depmod makes are used by hotplug, and we shouldn't
+	# need them, yet anyway.
+	find $(TREE)/lib/modules/ -name 'modules*' \
+		-not -name modules.dep -not -type d | xargs rm -f
 
 	# These files are used to build special kernel images for some
 	# subarchitectures. Move them out of the way.
@@ -415,3 +408,8 @@
 
 	# Library reduction. Existing libs from udebs are put in the udeblibs
 	# directory and mklibs is made to use those in preference to the
+	# system libs.
+	rm -rf $(TEMP)/udeblibs
+	mkdir -p $(TEMP)/udeblibs
+	-cp -a `find $(TREE)/lib -type f -name '*.so.*'` $(TEMP)/udeblibs
+	mkdir -p $(TREE)/lib

=== debian/changelog ===
debian-installer (20050317sarge2) oldstable; urgency=low

  * Change amd64 kernel from 2.6.8-11 to 2.6.8-12. Thanks Kurt Roeckx.
  * Fix kernel base version for sparc32 2.6 netboot kernel.
  * Support distribution equal to oldstable.
  * Update kernel versions for Sarge security updates with ABI change.

 -- Frans Pop <fjp@debian.org>  Tue,  3 Jul 2007 09:08:10 +0200

=== debian/rules ===
--- 
+++ 
@@ -2,9 +2,9 @@
 
 ARCH=$(shell dpkg-architecture -qDEB_BUILD_ARCH)
 VERSION=$(shell LC_ALL=C dpkg-parsechangelog | grep ^Version: | cut -d ' ' -f 2)
-DATE=$(shell echo $(VERSION) | cut -d '-' -f 1)
+DATE=$(shell echo $(VERSION) | cut -d '.' -f 1)
 DISTRIBUTION=$(shell LC_ALL=C dpkg-parsechangelog | grep ^Distribution: | cut -d ' ' -f 2)
-ifeq (${DISTRIBUTION},stable)
+ifneq (,$(filter stable oldstable,${DISTRIBUTION}))
 DISTRIBUTION=sarge
 endif
 ifeq (${DISTRIBUTION},unstable)
@@ -38,9 +38,9 @@
 build-stamp:
 	rm -f $@
 	-rm -rf $(MANTMP)
-#	set -e && cd doc/manual/build && \
-#	        official_build=1 destination=$(MANTMP) \
-#		architectures=$(ARCH) noarchdir=1 ./build.sh
+	set -e && cd doc/manual/build && \
+	        official_build=1 destination=$(MANTMP) \
+		architectures=$(ARCH) noarchdir=1 ./build.sh
 
 	$(MAKE) -C doc/devel/partman
 	
@@ -52,8 +52,8 @@
 	dh_clean -k
 	dh_installdirs
 	
-#	install -d $(MANDIR)
-#	cp -a $(MANTMP)/* $(MANDIR)
+	install -d $(MANDIR)
+	cp -a $(MANTMP)/* $(MANDIR)
 	
 	# Inclusion of a sources.list.udeb.local is needed to build d-i for
 	# Sarge 3.1r3 including updated kernel udebs. This hack makes sure
@@ -72,7 +72,7 @@
 	dh_testdir
 	dh_testroot
 	dh_installchangelogs
-#	dh_installdocs $(MANTMP)
+	dh_installdocs $(MANTMP)
 	dh_installdocs -X manual doc/* -X Makefile -X partman-doc.sgml
 	dh_compress
 	dh_fixperms
